#include "localtap.h"
#include "RasterFontBrowser.h"
#include "tapapifix.h"
#include <string.h>
#define ID_FREETYPE_TEST            0x07

TAP_ID( ID_FREETYPE_TEST );
TAP_PROGRAM_NAME("Font test precise noalloc hook");
TAP_AUTHOR_NAME("Justason");
TAP_DESCRIPTION("FontTest");
TAP_ETCINFO(__DATE__);

#define JUMP_CMD 0x08000000
#define NOP_CMD 0x00000000
#define REL_ADDR(x) (((dword)(x) & 0x0fffffff) >> 2)

dword hooked_PutS[2];
dword hooked_GetW[2];

void applyHook()
{
	dword *f = (dword*)&TAP_Osd_PutS;
	f = (dword*)*f;
	if(f[1] != NOP_CMD)
	{
		TAP_Print("%p %p %x\n",f,&TAP_Osd_PutS_HOOK,f[0]);
		hooked_PutS[0] = f[0];
		hooked_PutS[1] = f[1];
		f[0] = JUMP_CMD | REL_ADDR(&TAP_Osd_PutS_HOOK);
		f[1] = NOP_CMD;
		TAP_Print("%p %p %x\n",f,&TAP_Osd_PutS_HOOK,f[0]);

		f = (dword*)&TAP_Osd_GetW;
		f = (dword*)*f;
		hooked_GetW[0] = f[0];
		hooked_GetW[1] = f[1];
		f[0] = JUMP_CMD | REL_ADDR(&TAP_Osd_GetW_HOOK);
		f[1] = NOP_CMD;
	}
}

void removeHook()
{
	dword *f = (dword*)&TAP_Osd_PutS;
	f = (dword*)*f;
	if(f[1] == NOP_CMD)
	{
		f[0] = hooked_PutS[0];
		f[1] = hooked_PutS[1];

		f = (dword*)&TAP_Osd_GetW;
		f = (dword*)*f;
		f[0] = hooked_GetW[0];
		f[1] = hooked_GetW[1];
	}
}


int TAP_Main(void);
word rgn;
int _appl_version = 0x1200;
int transparency_orig;

#ifdef HOOK
FONT FONT_SMALL;
FONT FONT_MEDIUM;
FONT FONT_BIG;
#endif

#define DWORD_MAX ( (dword) -1)


dword TAP_EventHandler( word event, dword param1, dword param2 )
{
    static int count = 0, err1, filelen;
    static byte flip = 0;
    int i, y;
    const int LINE_H = 30;
    const int STR_COUNT = 7;
    char strings[7][40] = {
        {"Test ajJsjjOjsj"},
        {"qUIck tESt"},
        {"ma"},
        {"ke"},
        {"<< Nelonen >>"} ,
        {"03:20 "},
        {" leading SPACE"},
    };


    if( event == EVT_KEY )
    {
        if ( param1 == RKEY_Exit)
        {
            TAP_Osd_SetTransparency(rgn, 0xFF - transparency_orig);

            Delete_Font(&FONT_SMALL);
            Delete_Font(&FONT_MEDIUM);
            Delete_Font(&FONT_BIG);

            TAP_Osd_Delete( rgn );

            TAP_EnterNormal();
			TAP_Print("Removing hook\n");
            removeHook();

            TAP_Exit();
            return 0;
        }
        else if ( param1 == RKEY_1)
        {
            TAP_ExitNormal();
            TAP_Osd_FillBox(rgn, 30, 10, 620, 500, COLOR_DarkBlue);

            y = 20;
            for (i = 0; i < STR_COUNT; i++, y+=LINE_H)
            {
/*
                TAP_Osd_PutS_HOOK(rgn, 50, y,  199, strings[i], COLOR_Red, COLOR_White, 0, FNT_Size_1419, 0, ALIGN_LEFT);
                TAP_Osd_PutS_HOOK(rgn, 200, y, 349, strings[i], COLOR_Red, COLOR_White, 0, FNT_Size_1622, 0, ALIGN_LEFT);
                TAP_Osd_PutS_HOOK(rgn, 400, y, 550, strings[i], COLOR_Red, COLOR_White, 0, FNT_Size_1926, 0, ALIGN_LEFT);
*/
                TAP_Osd_PutS_HOOK(rgn, 50, y+240,  199, strings[i], COLOR_Red, COLOR_White, FONT_OVERRIDE, FNT_Size_1419, 0, ALIGN_LEFT);
                TAP_Osd_PutS_HOOK(rgn, 200, y+240, 349, strings[i], COLOR_Red, COLOR_White, FONT_OVERRIDE, FNT_Size_1622, 0, ALIGN_LEFT);
                TAP_Osd_PutS_HOOK(rgn, 400, y+240, 550, strings[i], COLOR_Red, COLOR_White, FONT_OVERRIDE, FNT_Size_1926, 0, ALIGN_LEFT);
            }
            return 0;
		}
        else if ( param1 == RKEY_2)
        {
            TAP_ExitNormal();
            TAP_Osd_FillBox(rgn, 30, 10, 620, 500, COLOR_Gray);

            y = 20;
            for (i = 0; i < STR_COUNT; i++, y+=LINE_H)
            {
/*
                TAP_Osd_PutS(rgn, 50, y,  199, strings[i], COLOR_Red, COLOR_White, 0, FNT_Size_1419, 0, ALIGN_LEFT);
                TAP_Osd_PutS(rgn, 200, y, 349, strings[i], COLOR_Red, COLOR_White, 0, FNT_Size_1622, 0, ALIGN_LEFT);
                TAP_Osd_PutS(rgn, 400, y, 550, strings[i], COLOR_Red, COLOR_White, 0, FNT_Size_1926, 0, ALIGN_LEFT);
*/
                TAP_Osd_PutS(rgn, 50, y+240,  199, strings[i], COLOR_Red, COLOR_White, FONT_OVERRIDE, FNT_Size_1419, 0, ALIGN_LEFT);
                TAP_Osd_PutS(rgn, 200, y+240, 349, strings[i], COLOR_Red, COLOR_White, FONT_OVERRIDE, FNT_Size_1622, 0, ALIGN_LEFT);
                TAP_Osd_PutS(rgn, 400, y+240, 550, strings[i], COLOR_Red, COLOR_White, FONT_OVERRIDE, FNT_Size_1926, 0, ALIGN_LEFT);
            }
            return 0;
        }
    }
    return param1;//event;
}

TAP_Funcs _TF;

int TAP_Main(void)
{
    int err1;

_TF.MemAlloc = TAP_MemAlloc;
_TF.MemFree = TAP_MemFree;
_TF.Osd_FillBox = TAP_Osd_FillBox;
_TF.Osd_DrawPixmap = TAP_Osd_DrawPixmap;


	TAP_Print("@ %p\n",_tap_startAddr);

    InitTAPAPIFix();
    transparency_orig = TAP_GetSystemVar( SYSVAR_OsdAlpha );
    rgn = TAP_Osd_Create(0, 0, 720, 576, 0, 0);

    TAP_Osd_SetTransparency( rgn, 150 );

    err1 = Load_Font(&FONT_SMALL, "font_small.rasterized");
    if (err1!=0) return 0;
    err1 = Load_Font(&FONT_MEDIUM, "font_medium.rasterized");
    if (err1!=0) return 0;
    err1 = Load_Font(&FONT_BIG, "font_big.rasterized");
    if (err1!=0) return 0;

	applyHook();

    return 1;
}
